/* dcc shtuff */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <varargs.h>
#include <errno.h>
#include <netinet/in.h>     /* hpux needs for ntohl */
#include "eggdrop.h"


extern int serv;
extern int require_x;
extern struct dcc_t dcc[];
extern int dcc_total;
extern char dccin[];
extern int conmask;
extern char botname[];
extern char origbotname[];
extern int isolate;
extern int require_p;
extern char dccdir[];
extern int flood_thr;

/* received a ctcp-dcc */
void gotdcc(nick,from,msg)
char *nick,*from,*msg;
{
  char code[512],param[512],s[256],s1[81],prt[81]; int z,i; FILE *f;
  nsplit(code,msg);
  if ((strcasecmp(code,"chat")!=0) && (strcasecmp(code,"send")!=0)) return;
  /* dcc chat or send! */
  nsplit(param,msg); nsplit(s,msg); nsplit(prt,msg);
  sprintf(s1,"%s!%s",nick,from);
  if (strcasecmp(code,"chat")==0) {
    int ok=0; char nk[40];
    if ((!require_p) || (!require_x)) if (match_op(s1)) ok=1;
    if ((match_master(s1)) || (match_xfer(s1)) || (match_party(s1))) ok=1;
    if (!ok) {
      mprintf(serv,"NOTICE %s :No access.\n",nick);
      log(LOG_MISC,"Refused DCC chat (no access): %s!%s",nick,from);
      return;
    }
    else {
      get_handle_by_host(nk,s1);
      if ((match_attr_handle(nk,USER_TANDEM)) && (in_chain(nk))) {
	mprintf(serv,"NOTICE %s :You're already connected.\n",nick);
	log(LOG_MISC,"Refused tandem connection from %s (duplicate)",nk);
	return;
      }
    }
  }
  if (strcasecmp(code,"send")==0) {
    int ok=0;
    if (!require_x) if (match_op(s1)) ok=1;
    if ((match_master(s1)) || (match_xfer(s1))) ok=1;
    if (!ok) {
      mprintf(serv,"NOTICE %s :No file transfer access.\n",nick);
      log(LOG_MISC,"Refused DCC SEND %s (no access): %s!%s",param,nick,from);
      return;
    }
  }
  if (dcc_total==MAXDCC) {
    mprintf(serv,"NOTICE %s :Sorry, too many DCC connections.\n",nick);
    log(LOG_MISC,"DCC connections full: %s %s (%s!%s)",code,param,nick,from);
    return;
  }
  if ((dccin[0]==0) && (strcasecmp(code,"send")==0)) {
    mprintf(serv,"NOTICE %s :DCC file transfers not supported.\n",nick);
    log(LOG_MISC,"Refused dcc send %s from %s!%s",param,nick,from);
    return;
  }
  if ((strchr(param,'/')!=NULL) && (strcasecmp(code,"send")==0)) {
    mprintf(serv,"NOTICE %s :Filename cannot have '/' in it...\n",nick);
    log(LOG_MISC,"Refused dcc send %s from %s!%s",param,nick,from);
    return;
  }
  i=dcc_total;
  dcc[i].addr=atol(s);
  dcc[i].port=atoi(prt);
  dcc[i].sock=(-1);
  dcc[i].type=DCC_FORK;
  strcpy(dcc[i].nick,nick);
  strcpy(dcc[i].host,from);
  dcc[i].u.other=NULL; set_fork(i);
  if (strcasecmp(code,"send")==0) {
    get_xfer_ptr(&(dcc[i].u.fork->u.xfer));
    if (param[0]=='.') param[0]='_';
    strcpy(dcc[i].u.fork->u.xfer->filename,param);
    dcc[i].u.fork->u.xfer->length=atol(msg);
    dcc[i].u.fork->u.xfer->sent=0;
    dcc[i].u.fork->u.xfer->sofar=0;
  }
  else {
    get_chat_ptr(&(dcc[i].u.fork->u.chat));
    dcc[i].u.fork->u.chat->away=NULL;
    dcc[i].u.fork->u.chat->status=0;
    dcc[i].u.fork->u.chat->timer=time(NULL);
    dcc[i].u.fork->u.chat->msgs_per_sec=0;
    dcc[i].u.fork->u.chat->con_flags=0;
  }
  if (strcasecmp(code,"chat")==0) {
    if (match_master(s1)) {
      z=DCC_CHAT;
      dcc[i].u.fork->u.chat->status|=STAT_MASTER;
    }
    else if (match_op(s1)) {
      if ((!require_p) || (match_party(s1))) z=DCC_CHAT;
      else if ((!require_x) || (match_xfer(s1))) z=DCC_FILES;
      else {
	mprintf(serv,"NOTICE %s :No access.\n",nick);
	log(LOG_MISC,"Refused dcc chat (no access): %s!%s",nick,from);
	return;
      }
    }
    else if (match_party(s1)) {
      z=DCC_CHAT;
      dcc[i].u.fork->u.chat->status|=STAT_PARTY;
    }
    else if (match_xfer(s1)) {
      z=DCC_FILES;
    }
    else {
      mprintf(serv,"NOTICE %s :No access.\n",nick);
      log(LOG_MISC,"Refused dcc chat (no access): %s!%s",nick,from);
      return;
    }
    if (match_xfer(s1)) dcc[i].u.fork->u.chat->status|=STAT_XFER;
    if (z==DCC_FILES) {
      /* ARGH: three level nesting */
      struct file_info *fi;
      get_file_ptr(&fi);
      fi->chat=dcc[i].u.fork->u.chat;
      dcc[i].u.fork->u.file=fi;
    }
  }
  else {
    z=DCC_SEND;
    sprintf(s1,"%s%s",dccin,param);
    f=fopen(s1,"r"); if (f!=NULL) {
      fclose(f);
      mprintf(serv,"NOTICE %s :That file already exists.\n",nick);
      nfree(dcc[i].u.xfer);
      return;
    }
    f=fopen(s1,"w"); if (f==NULL) {
      mprintf(serv,"NOTICE %s :Can't create that file.\n",nick);
      nfree(dcc[i].u.xfer);
      return;
    }
    fclose(f);
  }
  dcc[i].u.fork->type=z;     /* store future type */
  dcc_total++;
  /* ok, we're satisfied with them now: fork out and telnet to them */
  fork_telnet_dcc(i,s,prt);
}

void cont_got_dcc(z,idx)
int z,idx;
{
  char s1[121];
  if (z>0) {
    errno=z;
    neterror(s1);
    if (z==-2) strcpy(s1,"Can't find hostname lookup");
    if (z==-3) strcpy(s1,"Fake hostname -- not even trying");
    mprintf(serv,"NOTICE %s :Failed to connect (%s)\n",dcc[idx].nick,s1);
    log(LOG_MISC,"DCC connection failed: %s %s (%s!%s)",
	dcc[idx].u.fork->type==DCC_SEND?"SEND":"CHAT",dcc[idx].u.fork->type
	==DCC_SEND?dcc[idx].u.fork->u.xfer->filename:"",dcc[idx].nick,
	dcc[idx].host);
    log(LOG_MISC,"    (%s)",s1);
    dcc[idx].sock=dcc[idx].type; dcc[idx].type=DCC_LOST;
    return;
  }
  sprintf(s1,"%s!%s",dcc[idx].nick,dcc[idx].host); z=dcc[idx].sock;
  dcc[idx].type=dcc[idx].u.fork->type;
  {
    /* cut out the fork part of the chain */
    struct fork_info *fi=dcc[idx].u.fork;
    dcc[idx].u.other=fi->u.other;
    nfree(fi);
  }
  log(LOG_MISC,"DCC connection: %s %s (%s)",dcc[idx].type==DCC_SEND?"SEND":
      "CHAT",dcc[idx].type==DCC_SEND?dcc[idx].u.xfer->filename:"",s1);
  if (dcc[idx].type!=DCC_SEND) {
    get_handle_by_host(dcc[idx].nick,s1);
    dcc[idx].u.chat->timer=time(NULL);
    if (pass_match_by_host("nopass",s1)) {
      /* no password set */
      tprintf(z,"( YOU HAVE NO PASSWORD SET )\n");
      if (dcc[idx].type==DCC_CHAT) {
	if (dcc[idx].u.chat->status&STAT_MASTER) 
	  dcc[idx].u.chat->con_flags=conmask;
	dcc_chatter(z);
      }
      else {
	welcome_to_files(idx,z);
	log(LOG_MISC,"File system: [%s]%s/%d",dcc[idx].nick,dcc[idx].host,
		dcc[idx].port);
      }
    }
    else {
      tprintf(z,"Enter your password.\n");
      if (dcc[idx].type==DCC_CHAT) dcc[idx].type=DCC_CHAT_PASS;
      else dcc[idx].type=DCC_FILES_PASS;
    }
  }
}

int dcc_send(idx,z,filename,nick)
int idx,z; char *filename,*nick;
{
  int zz,port=0,i; char *p,nfn[121]; unsigned long host; struct stat ss;
  if (dcc_total==MAXDCC) {
    tprintf(z,"Sorry, too many DCC connections.\n");
    log(LOG_MISC,"DCC connections full: GET %s [%s]",filename,dcc[idx].nick);
    return 0;
  }
  zz=open_listen(&port);
  if (zz==-1) {
    tprintf(z,"Unable to listen at a socket.\n");
    log(LOG_MISC,"DCC socket error: GET %s [%s]",filename,dcc[idx].nick);
    return 0;
  }
  p=strrchr(filename,'/'); strcpy(nfn,p+1);
  host=getmyip();
  stat(filename,&ss);
  tprintf(z,"DCC sending '%s' to %s...\n",nfn,nick);
  if (strcasecmp(nick,dcc[idx].nick)!=0)
    mprintf(serv,"NOTICE %s :Here is a file from %s ...\n",nick,dcc[idx].nick);
  mprintf(serv,"PRIVMSG %s :%cDCC SEND %s %lu %d %lu%c\n",nick,1,nfn,host,
	  port,ss.st_size,1);
  if (dcc[idx].u.file->chat->status&STAT_TALK)
    tprintf(z,"/// GET %s\n",nfn);
  else
    tprintf(z,"Type '/DCC GET %s %s' to receive.\n",botname,nfn);
  i=dcc_total;
  dcc[i].sock=zz;
  dcc[i].addr=0;
  dcc[i].port=port;
  strcpy(dcc[i].nick,nick);
  if (strcasecmp(dcc[idx].nick,nick)==0)
    strcpy(dcc[i].host,dcc[idx].host);
  else strcpy(dcc[i].host,"(unknown)");
  dcc[i].type=DCC_GET_PENDING;
  set_xfer(i);
  strcpy(dcc[i].u.xfer->filename,filename);
  dcc[i].u.xfer->length=ss.st_size;
  dcc[i].u.xfer->sent=0;
  dcc[i].u.xfer->sofar=0;
  dcc[i].u.xfer->pending=time(NULL);
  dcc_total++;
  return 1;
}

int do_dcc_send(idx,z,dir,filename)
int idx,z; char *dir,*filename;
{
  char s[121],fn[256],nick[256]; FILE *f;
  /* nickname? */
  strcpy(nick,filename);
  nsplit(fn,nick);
  if (dccdir[0]==0) {
    tprintf(z,"DCC file transfers not supported.\n");
    log(LOG_MISC,"Refused dcc get %s from [%s]",fn,dcc[idx].nick);
    return 0;
  }
  if (strchr(fn,'/')!=NULL) {
    tprintf(z,"Filename cannot have '/' in it...\n");
    log(LOG_MISC,"Refused dcc get %s from [%s]",fn,dcc[idx].nick);
    return 0;
  }
  if (dir[0]) sprintf(s,"%s%s/%s",dccdir,dir,fn);
  else sprintf(s,"%s%s",dccdir,fn);
  f=fopen(s,"r"); if (f==NULL) {
    tprintf(z,"No such file.\n");
    log(LOG_MISC,"Refused dcc get %s from [%s]",fn,dcc[idx].nick);
    return 0;
  }
  fclose(f);
  if (!nick[0]) strcpy(nick,dcc[idx].nick);
  return dcc_send(idx,z,s,nick);
}  

int detect_dcc_flood(chat,idx)
struct chat_info *chat; int idx;
{
  int i; time_t t;
  t=time(NULL);
  if (chat->timer!=t) { chat->timer=t; chat->msgs_per_sec=0; }
  else {
    chat->msgs_per_sec++;
    if (chat->msgs_per_sec > flood_thr) {
      /* FLOOD */
      tprintf(dcc[idx].sock,"*** FLOOD: Goodbye.\n");
      chatout_but(idx,"*** %s forcibly removed from the party line for %s\n",
		  dcc[idx].nick,"flooding.");
      if (!isolate)
	tandout("chat %s %s booted for flooding.\n",origbotname,dcc[idx].nick);
      if (dcc[idx].sock!=STDOUT) {
	close(dcc[idx].sock); shutdown(dcc[idx].sock,2); lostdcc(idx);
      }
      else {
	tprintf(STDOUT,"\n### SIMULATION RESET ###\n\n");
	dcc_chatter(STDOUT);
      }
      return 1;  /* <- flood */
    }
  }
  return 0;
}
