/* user data manipulation -- separated from old 'chanprog' cos it was
   getting way too big */

#include <stdio.h>
#include <string.h>
#include <time.h>
#include "eggdrop.h"
#include "users.h"

extern char botname[];
extern char botuser[];
extern char bothost[];
extern int serv;
extern char curchan[];
extern struct dcc_t dcc[];
extern int dcc_total;
extern char userfile[];
extern int periodic_save;
extern int cx_line;
extern char cx_file[];

/* are we still loading config file? (don't autosave) */
int nosave=1;
/* don't send out to sharebots */
int noshare=1;
/* user records are stored here */
struct userrec *userlist=NULL;

struct queue *add_q(ss,q)
char *ss; struct queue *q;
{
  char s[512]; struct queue *x; char s1[121],*p;
  strcpy(s,ss); do {
    p=strchr(s,','); if (p!=NULL) { *p=0; p++; strcpy(s1,p); } else s1[0]=0;
    rmspace(s); rmspace(s1);
    x=(struct queue *)nmalloc(sizeof(struct queue));
    x->next=q;
    x->item=(char *)nmalloc(strlen(s)+1);
    strcpy(x->item,s); s[0]=0; strcpy(s,s1);
  } while (s[0]);
  return x;
}

struct queue *del_q(s,q,ok)
char *s; struct queue *q; int *ok;
{
  struct queue *x,*x1,*ret,*old;
  x=q; ret=q; old=q; *ok=0; while (x!=NULL) {
    if (strcasecmp(x->item,s)==0) {
      if (x==ret) {
	ret=(x->next); nfree(x->item); nfree(x); x=ret;
      }
      else {
	old->next=x->next; nfree(x->item); nfree(x); x=old->next;
      }
      *ok=1;
    }
    else { old=x; x=x->next; }
  }
  return ret;
}

/* memory we should be using */
int expmem_users()
{
  int tot,i; struct userrec *u; struct queue *s;
  tot=0;
  for (i=0; i<dcc_total+1; i++) {
    if (i==dcc_total) u=userlist;
    else {
      if (dcc[i].type==DCC_TANDEM) u=dcc[i].u.tand->user;
      else u=NULL;
    }
    while (u!=NULL) {
      if (u->email!=NULL) tot+=strlen(u->email)+1;
      if (u->dccdir!=NULL) tot+=strlen(u->dccdir)+1;
      if (u->comment!=NULL) tot+=strlen(u->comment)+1;
      if (u->info!=NULL) tot+=strlen(u->info)+1;
      s=u->host; while (s!=NULL) {
	tot+=strlen(s->item)+1;
	tot+=sizeof(struct queue);
	s=s->next;
      }
      tot+=sizeof(struct userrec);
      u=u->next;
    }
  }
  return tot;
}

int str2flags(s)
char *s;
{
  int i,f=0;
  for (i=0; i<strlen(s); i++) {
    if (s[i]=='o') f|=USER_OP;
    if (s[i]=='d') f|=USER_DEOP;
    if (s[i]=='b') f|=USER_BAN;
    if (s[i]=='k') f|=USER_KICK;
    if (s[i]=='m') f|=USER_MASTER;
    if (s[i]=='f') f|=USER_FRIEND;
    if (s[i]=='x') f|=USER_XFER;
    if (s[i]=='i') f|=USER_IGNORE;
    if (s[i]=='t') f|=USER_TANDEM;
    if (s[i]=='p') f|=USER_PARTY;
    if (s[i]=='s') f|=BOT_SHARE;
    if (s[i]=='a') f|=BOT_AUTO;
    if (s[i]=='l') f|=BOT_LEAF;
    if (s[i]=='r') f|=BOT_REJECT;
  }
  return f;
}

void flags2str(f,s)
int f; char *s;
{
  s[0]=0;
  if (f&USER_OP) strcat(s,"o");
  if (f&USER_DEOP) strcat(s,"d");
  if (f&USER_BAN) strcat(s,"b");
  if (f&USER_KICK) strcat(s,"k");
  if (f&USER_MASTER) strcat(s,"m");
  if (f&USER_FRIEND) strcat(s,"f");
  if (f&USER_XFER) strcat(s,"x");
  if (f&USER_IGNORE) strcat(s,"i");
  if (f&USER_TANDEM) {
    strcat(s,"t");
    if (f&BOT_SHARE) strcat(s,"s");
    if (f&BOT_AUTO) strcat(s,"a");
    if (f&BOT_LEAF) strcat(s,"l");
    if (f&BOT_REJECT) strcat(s,"r");
  }
  else {
    if (f&USER_PARTY) strcat(s,"p");
  }
  if (s[0]==0) strcat(s,"-");
}

int count_users()
{ 
  int tot=0; struct userrec *u=userlist;
  while (u!=NULL) {
    tot++;
    u=u->next;
  }
  return tot;
}

int count_users2(bu)
struct userrec *bu;
{
  int tot=0; struct userrec *u=bu;
  while (u!=NULL) {
    tot++;
    u=u->next;
  }
  return tot;
}

struct userrec *get_user_by_handle(handle)
char *handle;
{
  struct userrec *u=userlist;
  if (handle==NULL) return NULL;
  rmspace(handle); if (!handle[0]) return NULL;
  while (u!=NULL) {
    if (strcasecmp(u->handle,handle)==0) return u;
    u=u->next;
  }
  return NULL;
}

struct userrec *get_user_by_handle2(bu,handle)
struct userrec *bu; char *handle;
{
  struct userrec *u=bu;
  if (handle==NULL) return NULL;
  rmspace(handle); if (!handle[0]) return NULL;
  while (u!=NULL) {
    if (strcasecmp(u->handle,handle)==0) return u;
    u=u->next;
  }
  return NULL;
}

int is_user(handle)
char *handle;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) return 0;
  else return 1;
}

/* fix capitalization, etc */
void correct_handle(handle)
char *handle;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) return;
  strcpy(handle,u->handle);
}

void clear_userlist()
{
  struct userrec *u=userlist,*v;
  while (u!=NULL) {
    clearq(u->host);
    if (u->email!=NULL) nfree(u->email);
    if (u->dccdir!=NULL) nfree(u->dccdir);
    if (u->comment!=NULL) nfree(u->comment);
    if (u->info!=NULL) nfree(u->info);
    v=u->next; nfree(u);
    u=v;
  }
  userlist=NULL;
}

void clear_userlist2(bu)
struct userrec *bu;
{
  struct userrec *u=bu,*v;
  while (u!=NULL) {
    clearq(u->host);
    if (u->email!=NULL) nfree(u->email);
    if (u->dccdir!=NULL) nfree(u->dccdir);
    if (u->comment!=NULL) nfree(u->comment);
    if (u->info!=NULL) nfree(u->info);
    v=u->next; nfree(u); u=v;
  }
  /* anything calling clear_userlist2 needs to set their userrec * to
     NULL by themselves -- no more babying :)  */
}

/* find CLOSEST host match */
/* (if "*!*@*" and "*!*@*clemson.edu" both match, use the latter!) */
struct userrec *get_user_by_host(host)
char *host;
{
  struct userrec *u=userlist,*ret; struct queue *q; int cnt,i;
  if (host==NULL) return NULL;
  rmspace(host); if (!host[0]) return NULL;
  ret=NULL; cnt=0;
  while (u!=NULL) {
    q=u->host;
    while (q!=NULL) {
      i=wild_match(q->item,host);
      if (i>cnt) { ret=u; cnt=i; }
      q=q->next;
    }
    u=u->next;
  }
  return ret;
}

void get_handle_by_host(nick,host)
char *nick,*host;
{
  struct userrec *u;
  u=get_user_by_host(host);
  if (u==NULL) { nick[0]='*'; nick[1]=0; return; }
  strcpy(nick,u->handle);
}

struct userrec *get_user_by_equal_host(host)
char *host;
{
  struct userrec *u=userlist; struct queue *q;
  while (u!=NULL) {
    q=u->host;
    while (q!=NULL) {
      if (strcasecmp(q->item,host)==0) return u;
      q=q->next;
    }
    u=u->next;
  }
  return NULL;
}

/* try: pass_match_by_host("nopass",host)
   will return 1 if no password is set for that host   */
int pass_match_by_host(pass,host)
char *pass,*host;
{
  struct userrec *u;
  u=get_user_by_host(host);
  if (u==NULL) return 0;
  if (strcasecmp(u->pass,"nopass")==0) return 1;
  if (strcasecmp(u->pass,pass)!=0) return 0;
  else return 1;
}

int pass_match_by_handle(pass,handle)
char *pass,*handle;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) return 0;
  if (strcasecmp(u->pass,"nopass")==0) return 1;
  if (strcasecmp(u->pass,pass)!=0) return 0;
  else return 1;
}

void get_pass_by_handle(handle,pass)
char *handle,*pass;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) { pass[0]=0; return; }
  strcpy(pass,u->pass);
  return;
}

void write_user(u,f)
struct userrec *u; FILE *f;
{
  char host[81],s[121]; struct queue *q;
  if (u->flags&USER_PURGE) {
    u->flags&=(~USER_PURGE);
    return;
  }
  flags2str(u->flags,s);
  strcpy(host,u->host->item);
  if (strlen(host)>38) { strcpy(host,"$placeholder$"); q=u->host; }
  else q=u->host->next;
  fprintf(f,"%-10s%-40s%-10s%-10s%lu\n",u->handle,host,u->pass,s,u->laston);
  s[0]=0; while (q!=NULL) {
    if (!s[0]) sprintf(s,"%-10s%s","-",q->item);
    else {
      if (strlen(s)+strlen(q->item)+2>70) {
	fprintf(f,"%s\n",s);
	sprintf(s,"%-10s%s","-",q->item);
      }
      else {
	strcat(s,", "); strcat(s,q->item);
      }
    }
    q=q->next;
  }
  if (s[0]) fprintf(f,"%s\n",s);
  if (u->email!=NULL) fprintf(f,"%-10s%s\n","+",u->email);
  if (u->dccdir!=NULL) fprintf(f,"%-10s%s\n","*",u->dccdir);
  if (u->comment!=NULL) fprintf(f,"%-10s%s\n","=",u->comment);
  if (u->info!=NULL) fprintf(f,"%-10s%s\n",":",u->info);
}

/* rewrite the entire user file */
void write_userfile()
{
  FILE *f; char s[121],s1[81]; time_t tt; struct userrec *u;
  sprintf(s,"%s~new",userfile);
  f=fopen(s,"w");
  if (f==NULL) {
    log(LOG_MISC,"ERROR in writing save file.");
    return;
  }
  log(LOG_MISC,"Writing user file ...");
  tt=time(NULL); strcpy(s1,ctime(&tt));
  fprintf(f,"# wrote user file: %s",s1);
  u=userlist; while (u!=NULL) {
    write_user(u,f);
    u=u->next;
  }
  fclose(f); unlink(userfile);
#ifdef RENAME
  sprintf(s,"%s~new",userfile); rename(s,userfile);
#else
  sprintf(s,"mv %s~new %s",userfile,userfile); system(s);
#endif
}

/* new save-user is just like write-userfile */
void save_user(ux)
struct userrec *ux;    /* unused currently */
{
  FILE *f; char s[121],s1[81]; time_t tt; struct userrec *u;
  sprintf(s,"%s~new",userfile);
  f=fopen(s,"w");
  if (f==NULL) {
    log(LOG_MISC,"ERROR in writing save file.");
    return;
  }
  tt=time(NULL); strcpy(s1,ctime(&tt));
  fprintf(f,"# wrote user file: %s",s1);
  u=userlist; while (u!=NULL) {
    write_user(u,f);
    u=u->next;
  }
  fclose(f); unlink(userfile);
#ifdef RENAME
  sprintf(s,"%s~new",userfile); rename(s,userfile);
#else
  sprintf(s,"mv %s~new %s",userfile,userfile); system(s);
#endif
}

void purge_user(u)
struct userrec *u;
{
  u->flags|=USER_PURGE;
  if (!nosave) save_user(u);
}
	
void change_pass_by_handle(handle,pass)
char *handle,*pass;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) return;
  strcpy(u->pass,pass);
  if (!nosave) save_user(u);
  if (!noshare) shareout("chpass %s %s\n",handle,pass);
}

void change_pass_by_host(host,pass)
char *host,*pass;
{
  struct userrec *u;
  u=get_user_by_host(host);
  if (u==NULL) return;
  strcpy(u->pass,pass);
  if (!nosave) save_user(u);
  if (!noshare) shareout("chpass %s %s\n",u->handle,pass);
}

void change_handle(oldh,newh)
char *oldh,*newh;
{
  struct userrec *u;
  u=get_user_by_handle(oldh);
  if (u==NULL) return;
  purge_user(u);
  strcpy(u->handle,newh);
  if (!nosave) save_user(u);
  if (!noshare) shareout("chhand %s %s\n",oldh,newh);
}

void adduser(handle,host,pass,flags)
char *handle,*host,*pass; int flags;
{
  struct userrec *u;
  u=(struct userrec *)nmalloc(sizeof(struct userrec));
  u->next=userlist; userlist=u;
  strcpy(u->handle,handle); strcpy(u->pass,pass);
  u->host=NULL;
  if (host[0]) u->host=add_q(host,u->host);
  u->flags=flags; u->laston=0L;
  u->email=NULL; u->dccdir=NULL; u->comment=NULL; u->info=NULL;
  if (!nosave) save_user(u);
  if ((!noshare) && (handle[0]!='*'))
    shareout("newuser %s %s %s %d\n",handle,host,pass,flags);
}

struct userrec *adduser2(bu,handle,host,pass,flags)
struct userrec *bu; char *handle,*host,*pass; int flags;
{
  struct userrec *u;
  u=(struct userrec *)nmalloc(sizeof(struct userrec));
  u->next=bu; bu=u;
  strcpy(u->handle,handle); strcpy(u->pass,pass);
  u->host=NULL;
  if (host[0]) u->host=add_q(host,u->host);
  u->flags=flags; u->laston=0L;
  u->email=NULL; u->dccdir=NULL; u->comment=NULL; u->info=NULL;
  return bu;
}

/* create a copy of the entire userlist (for sending user lists to
   clone bots) -- userlist is reversed in the process, which is OK
   because the receiving bot reversed the list AGAIN when saving */
struct userrec *dup_userlist()
{
  struct userrec *u,*u1,*nu; struct queue *q;
  nu=NULL; u=userlist;
  while (u!=NULL) {
    u1=(struct userrec *)nmalloc(sizeof(struct userrec));
    u1->next=nu; nu=u1;
    strcpy(nu->handle,u->handle); strcpy(nu->pass,u->pass);
    q=u->host; nu->host=NULL;
    while (q!=NULL) {
      nu->host=add_q(q->item,nu->host);
      q=q->next;
    }
    nu->flags=u->flags; nu->laston=u->laston;
    if (u->email!=NULL) {
      nu->email=(char *)nmalloc(strlen(u->email)+1);
      strcpy(nu->email,u->email);
    }
    else nu->email=NULL;
    if (u->dccdir!=NULL) {
      nu->dccdir=(char *)nmalloc(strlen(u->dccdir)+1);
      strcpy(nu->dccdir,u->dccdir);
    }
    else nu->dccdir=NULL;
    if (u->comment!=NULL) {
      nu->comment=(char *)nmalloc(strlen(u->comment)+1);
      strcpy(nu->comment,u->comment);
    }
    else nu->comment=NULL;
    if (u->info!=NULL) {
      nu->info=(char *)nmalloc(strlen(u->info)+1);
      strcpy(nu->info,u->info);
    }
    else nu->info=NULL;
    u=u->next;
  }
  return nu;
}

void freeuser(u)
struct userrec *u;
{
  clearq(u->host);
  if (u->email!=NULL) nfree(u->email);
  if (u->dccdir!=NULL) nfree(u->dccdir);
  if (u->comment!=NULL) nfree(u->comment);
  if (u->info!=NULL) nfree(u->info);
  nfree(u);
}

int deluser(handle)
char *handle;
{
  struct userrec *u=userlist,*prev=NULL; int fnd=0;
  while ((u!=NULL) && (!fnd)) {
    if (strcasecmp(u->handle,handle)==0) fnd=1;
    else { prev=u; u=u->next; }
  }
  if (!fnd) return 0;
  if (prev==NULL) userlist=u->next;
  else prev->next=u->next;
  if (!nosave) purge_user(u);
  if ((!noshare) && (handle[0]!='*')) shareout("killuser %s\n",handle);
  freeuser(u);
  return 1;
}

int delhost_by_handle(handle,host)
char *handle,*host;
{
  struct userrec *u; int i;
  u=get_user_by_handle(handle);
  if (u==NULL) return 0;
  u->host=del_q(host,u->host,&i);
  if (u->host==NULL) u->host=add_q("none",u->host);
  if ((!nosave) && (i)) save_user(u);
  if ((!noshare) && (i)) shareout("-host %s %s\n",handle,host);
  return i;
}

void addhost_by_handle(handle,host)
char *handle,*host;
{
  struct userrec *u; int i;
  u=get_user_by_handle(handle);
  if (u==NULL) return;
  if (u->host!=NULL) if (strcmp(u->host->item,"none")==0)
    u->host=del_q("none",u->host,&i);
  u->host=add_q(host,u->host);
  if (!nosave) save_user(u);
  if (!noshare) shareout("+host %s %s\n",handle,host);
}

void addhost_by_handle2(bu,handle,host)
struct userrec *bu; char *handle,*host;
{
  struct userrec *u; int i;
  u=get_user_by_handle2(bu,handle);
  if (u==NULL) return;
  if (u->host!=NULL) if (strcmp(u->host->item,"none")==0)
    u->host=del_q("none",u->host,&i);
  u->host=add_q(host,u->host);
}

void addhost_by_host(matchhost,host)
char *matchhost,*host;
{ 
  struct userrec *u; int i;
  u=get_user_by_host(matchhost);
  if (u==NULL) return;
  if (u->host!=NULL) if (strcmp(u->host->item,"none")==0)
    u->host=del_q("none",u->host,&i);
  u->host=add_q(host,u->host);
  if (!nosave) save_user(u);
  if (!noshare) shareout("+host %s %s\n",u->handle,host);
}

void set_handle_email(handle,email)
char *handle,*email;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) return;
  if (u->email!=NULL) nfree(u->email);
  if (email[0]) {
    u->email=(char *)nmalloc(strlen(email)+1);
    strcpy(u->email,email);
  }
  else u->email=NULL;
  if (!nosave) save_user(u);
  if (!noshare) shareout("chemail %s %s\n",handle,email);
}

void set_handle_email2(bu,handle,email)
struct userrec *bu; char *handle,*email;
{
  struct userrec *u;
  u=get_user_by_handle2(bu,handle);
  if (u==NULL) return;
  if (u->email!=NULL) nfree(u->email);
  if (email[0]) {
    u->email=(char *)nmalloc(strlen(email)+1);
    strcpy(u->email,email);
  }
  else u->email=NULL;
}

void get_handle_email(handle,s)
char *handle; char *s;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) { s[0]=0; return; }
  if (u->email==NULL) { s[0]=0; return; }
  strcpy(s,u->email); return;
}

void get_handle_dccdir(handle,s)
char *handle; char *s;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) { s[0]=0; return; }
  if (u->dccdir==NULL) { s[0]=0; return; }
  strcpy(s,u->dccdir); return;
}

void get_handle_comment(handle,s)
char *handle; char *s;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) { s[0]=0; return; }
  if (u->comment==NULL) { s[0]=0; return; }
  strcpy(s,u->comment); return;
}

void get_handle_info(handle,s)
char *handle; char *s;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) { s[0]=0; return; }
  if (u->info==NULL) { s[0]=0; return; }
  strcpy(s,u->info); return;
}

void set_handle_dccdir(handle,dir)
char *handle,*dir;
{
  struct userrec *u;
  if (strlen(dir)>80) dir[80]=0;
  u=get_user_by_handle(handle);
  if (u==NULL) return;
  if (u->dccdir!=NULL) nfree(u->dccdir);
  if (dir[0]) {
    u->dccdir=(char *)nmalloc(strlen(dir)+1);
    strcpy(u->dccdir,dir);
  }
  else u->dccdir=NULL;
  if (!nosave) save_user(u);
  if (!noshare) shareout("chdccdir %s %s\n",handle,dir);
}

void set_handle_dccdir2(bu,handle,dir)
struct userrec *bu; char *handle,*dir;
{
  struct userrec *u;
  if (strlen(dir)>80) dir[80]=0;
  u=get_user_by_handle2(bu,handle);
  if (u==NULL) return;
  if (u->dccdir!=NULL) nfree(u->dccdir);
  if (dir[0]) {
    u->dccdir=(char *)nmalloc(strlen(dir)+1);
    strcpy(u->dccdir,dir);
  }
  else u->dccdir=NULL;
}

void set_handle_comment(handle,comment)
char *handle,*comment;
{
  struct userrec *u;
  if (strlen(comment)>80) comment[80]=0;
  u=get_user_by_handle(handle);
  if (u==NULL) return;
  if (u->comment!=NULL) nfree(u->comment);
  if (comment[0]) {
    u->comment=(char *)nmalloc(strlen(comment)+1);
    strcpy(u->comment,comment);
  }
  else u->comment=NULL;
  if (!nosave) save_user(u);
  if (!noshare) shareout("chcomment %s %s\n",handle,comment);
}

void set_handle_comment2(bu,handle,comment)
struct userrec *bu; char *handle,*comment;
{
  struct userrec *u;
  if (strlen(comment)>80) comment[80]=0;
  u=get_user_by_handle2(bu,handle);
  if (u==NULL) return;
  if (u->comment!=NULL) nfree(u->comment);
  if (comment[0]) {
    u->comment=(char *)nmalloc(strlen(comment)+1);
    strcpy(u->comment,comment);
  }
  else u->comment=NULL;
}

void set_handle_info(handle,info)
char *handle,*info;
{
  struct userrec *u;
  if (strlen(info)>80) info[80]=0;
  u=get_user_by_handle(handle);
  if (u==NULL) return;
  if (u->info!=NULL) nfree(u->info);
  if (info[0]) {
    u->info=(char *)nmalloc(strlen(info)+1);
    strcpy(u->info,info);
  }
  else u->info=NULL;
  if (!nosave) save_user(u);
  if (!noshare) shareout("chinfo %s %s\n",handle,info);
}

void set_handle_info2(bu,handle,info)
struct userrec *bu; char *handle,*info;
{
  struct userrec *u;
  if (strlen(info)>80) info[80]=0;
  u=get_user_by_handle2(bu,handle);
  if (u==NULL) return;
  if (u->info!=NULL) nfree(u->info);
  if (info[0]) {
    u->info=(char *)nmalloc(strlen(info)+1);
    strcpy(u->info,info);
  }
  else u->info=NULL;
}

int chg_attr_u(u,chg,which)
struct userrec *u; char chg; int which;
{
  if (u==NULL) return 0;
  if (chg=='+') {
    if (u->flags&which) return 0;
    u->flags |= which;
    if (!nosave) save_user(u);
    if (!noshare) shareout("+attr %s %d\n",u->handle,which);
    return 1;
  }
  else {
    if (!(u->flags&which)) return 0;
    u->flags &= ~which; 
    if (!nosave) save_user(u);
    if (!noshare) shareout("-attr %s %d\n",u->handle,which);
    return 1;
  }
}

int chg_attr_by_handle(handle,chg,which)
char *handle,chg; int which;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u!=NULL) return chg_attr_u(u,chg,which);
  else return 0;
}

int chg_attr_by_host(host,chg,which)
char *host,chg; int which;
{
  struct userrec *u;
  u=get_user_by_host(host);
  if (u!=NULL) return chg_attr_u(u,chg,which);
  else return 0;
}

/* return 1 if it was successful */
/* change attr by handle or host (depending on whether ident has '@') */
int change_attr(ident,chg,which)
char *ident,chg; int which;
{
  if (ident==NULL) return 0;
  if (!ident[0]) return 0;
  if (strchr(ident,'@')==NULL) {
    /* handle? */
    return chg_attr_by_handle(ident,chg,which);
  }
  else return chg_attr_by_host(ident,chg,which);
}

int prog_deop(s) char *s; { return chg_attr_by_host(s,'+',USER_DEOP); }
int unprog_deop(s) char *s; { return chg_attr_by_host(s,'-',USER_DEOP); }
int prog_op(s) char *s; { return chg_attr_by_host(s,'+',USER_OP); }
int unprog_op(s) char *s; { return chg_attr_by_host(s,'-',USER_OP); }
int prog_master(s) char *s; { return chg_attr_by_host(s,'+',USER_MASTER); }
int unprog_master(s) char *s; { return chg_attr_by_host(s,'-',USER_MASTER); }
int prog_kick(s) char *s; { return chg_attr_by_host(s,'+',USER_KICK); }
int unprog_kick(s) char *s; { return chg_attr_by_host(s,'-',USER_KICK); }
int prog_friend(s) char *s; { return chg_attr_by_host(s,'+',USER_FRIEND); }
int unprog_friend(s) char *s; { return chg_attr_by_host(s,'-',USER_FRIEND); }

int match_attr_handle(handle,which)
char *handle; int which;
{
  struct userrec *u;
  u=get_user_by_handle(handle);
  if (u==NULL) return 0;
  if (u->flags&which) return 1;
  else return 0;
}

int match_attr(host,which)
char *host; int which;
{
  struct userrec *u;
  u=get_user_by_host(host);
  if (u==NULL) return 0;
  if (u->flags&which) return 1;
  else return 0;
}

int match_op(user) char *user; { return match_attr(user,USER_OP); }
int match_deop(user) char *user; { return match_attr(user,USER_DEOP); }
int match_kick(user) char *user; { return match_attr(user,USER_KICK); }
int match_master(user) char *user; { return match_attr(user,USER_MASTER); }
int match_friend(user) char *user; { return match_attr(user,USER_FRIEND); }
int match_xfer(user) char *user; { return match_attr(user,USER_XFER); }
int match_tandem(user) char *user; { return match_attr(user,USER_TANDEM); }
int match_party(user) char *user; { return match_attr(user,USER_PARTY); }
